/*
   When we compare this program with struct_1.c
   we see how the C language treats arrays and
   structs in different ways.

   With arrays, the bracket notation for an array
   element is equivalent to the pointer notation for
   an array element (array names "decay" to a pointer).
*/
#include <stdlib.h>
#include <stdio.h>

int main()
{
   int a1[5];                          // a1 is declared as an array value
   int * a2 = malloc(5 * sizeof(int)); // a2 is declared as an array pointer
   a1[1] = 3;
   a2[1] = 3;      // hide the fact that a2 is a pointer
   *(a1 + 2) = 4;  // show that a1 decays to a pointer
   *(a2 + 2) = 4;

   printf("%d %d %d %d %d\n", a1[0], a1[1], a1[2], a1[3], a1[4]);
   printf("%d %d %d %d %d\n", a2[0], a2[1], a2[2], a2[3], a2[4]);

   free(a2);

   return 0;
}
