/*
   When we compare this program with array_1.c
   we see how the C language treats arrays and
   structs in different ways.

   With structs, the notation for a member of a
   struct value is different from the notation
   for a member of a struct pointer.
*/
#include <stdlib.h>
#include <stdio.h>

struct S {
   int n;
   double x;
};

int main()
{
   struct S s1 = {4, 5.6};                   // s1 is declared as a struct value
   struct S * s2 = malloc(sizeof(struct S)); // s2 is declared as a struct pointer
   s1.x = 7.8;     // use dot notation with struct values
   s2->x = 7.8;    // use arrow notation with struct pointers
   (*s2).x = 8.9;  // dereference the struct pointer to a struct value

   printf("%d %f %d %f\n", s1.n, s1.x, s2->n, s2->x);

   free (s2);

   return 0;
}
